#include <Yafridng.h>
#include <Ice/Application.h>
#include <FileStoreI.h>
#include <FileManager.h>

using namespace std;

class FileClient : virtual public Ice::Application
{
  void printHelp(){
    cout << "Usage: ./FileClient --Ice.Config=client.cfg <Serverfile>" << endl;
  }

  virtual int run(int argc, char *argv[]){
    if(argc == 1)
      printHelp();

    else{
      Ice::ByteSeq bytes;
      Ice::ObjectPrx obj = communicator()->stringToProxy("Store:tcp -p 10000");
      Yafridng::FileStorePrx store = Yafridng::FileStorePrx::checkedCast(obj);
      
      if(!store)
	cout << "Error obtaining proxy" << endl;

      /* Getting a proxy for reading the file specified in argv[1] */
      Yafridng::FilePrx file = store->read(argv[1], 10, 0);

      /* Using fileManager for reading the whole file */
      FileManager manager(argv[1], file, "wb");
      manager.getFile();
    }
  }
};

int main(int argc, char *argv[]){
  FileClient client;
  return client.main(argc, argv);
}
