// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `Yafridng.ice'

#include <Yafridng.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Yafridng__File__next_name = "next";

static const ::std::string __Yafridng__FileStore__read_name = "read";

::Ice::Object* IceInternal::upCast(::Yafridng::File* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Yafridng::File* p) { return p; }

::Ice::Object* IceInternal::upCast(::Yafridng::FileStore* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Yafridng::FileStore* p) { return p; }

void
Yafridng::__read(::IceInternal::BasicStream* __is, ::Yafridng::FilePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Yafridng::File;
        v->__copyFrom(proxy);
    }
}

void
Yafridng::__read(::IceInternal::BasicStream* __is, ::Yafridng::FileStorePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Yafridng::FileStore;
        v->__copyFrom(proxy);
    }
}

bool
Yafridng::Piece::operator==(const Piece& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(offset != __rhs.offset)
    {
        return false;
    }
    if(pieceSize != __rhs.pieceSize)
    {
        return false;
    }
    return true;
}

bool
Yafridng::Piece::operator<(const Piece& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(offset < __rhs.offset)
    {
        return true;
    }
    else if(__rhs.offset < offset)
    {
        return false;
    }
    if(pieceSize < __rhs.pieceSize)
    {
        return true;
    }
    else if(__rhs.pieceSize < pieceSize)
    {
        return false;
    }
    return false;
}

void
Yafridng::Piece::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(offset);
    __os->write(pieceSize);
}

void
Yafridng::Piece::__read(::IceInternal::BasicStream* __is)
{
    __is->read(offset);
    __is->read(pieceSize);
}

void
Yafridng::__writePieces(::IceInternal::BasicStream* __os, const ::Yafridng::Piece* begin, const ::Yafridng::Piece* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
Yafridng::__readPieces(::IceInternal::BasicStream* __is, ::Yafridng::Pieces& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->checkFixedSeq(sz, 8);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
    }
}

Yafridng::YafridngException::YafridngException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Yafridng::YafridngException::~YafridngException() throw()
{
}

static const char* __Yafridng__YafridngException_name = "Yafridng::YafridngException";

::std::string
Yafridng::YafridngException::ice_name() const
{
    return __Yafridng__YafridngException_name;
}

::Ice::Exception*
Yafridng::YafridngException::ice_clone() const
{
    return new YafridngException(*this);
}

void
Yafridng::YafridngException::ice_throw() const
{
    throw *this;
}

void
Yafridng::YafridngException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Yafridng::YafridngException"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Yafridng::YafridngException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Yafridng::YafridngException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Yafridng::YafridngException was not generated with stream support";
    throw ex;
}

void
Yafridng::YafridngException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Yafridng::YafridngException was not generated with stream support";
    throw ex;
}

struct __F__Yafridng__YafridngException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Yafridng::YafridngException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Yafridng__YafridngException__Ptr = new __F__Yafridng__YafridngException;

const ::IceInternal::UserExceptionFactoryPtr&
Yafridng::YafridngException::ice_factory()
{
    return __F__Yafridng__YafridngException__Ptr;
}

class __F__Yafridng__YafridngException__Init
{
public:

    __F__Yafridng__YafridngException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Yafridng::YafridngException", ::Yafridng::YafridngException::ice_factory());
    }

    ~__F__Yafridng__YafridngException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Yafridng::YafridngException");
    }
};

static __F__Yafridng__YafridngException__Init __F__Yafridng__YafridngException__i;

#ifdef __APPLE__
extern "C" { void __F__Yafridng__YafridngException__initializer() {} }
#endif

Yafridng::FileAccessException::FileAccessException(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    YafridngException(__ice_reason)
#else
    ::Yafridng::YafridngException(__ice_reason)
#endif
{
}

Yafridng::FileAccessException::~FileAccessException() throw()
{
}

static const char* __Yafridng__FileAccessException_name = "Yafridng::FileAccessException";

::std::string
Yafridng::FileAccessException::ice_name() const
{
    return __Yafridng__FileAccessException_name;
}

::Ice::Exception*
Yafridng::FileAccessException::ice_clone() const
{
    return new FileAccessException(*this);
}

void
Yafridng::FileAccessException::ice_throw() const
{
    throw *this;
}

void
Yafridng::FileAccessException::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Yafridng::FileAccessException"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    YafridngException::__write(__os);
#else
    ::Yafridng::YafridngException::__write(__os);
#endif
}

void
Yafridng::FileAccessException::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    YafridngException::__read(__is, true);
#else
    ::Yafridng::YafridngException::__read(__is, true);
#endif
}

void
Yafridng::FileAccessException::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Yafridng::FileAccessException was not generated with stream support";
    throw ex;
}

void
Yafridng::FileAccessException::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Yafridng::FileAccessException was not generated with stream support";
    throw ex;
}

struct __F__Yafridng__FileAccessException : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Yafridng::FileAccessException();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Yafridng__FileAccessException__Ptr = new __F__Yafridng__FileAccessException;

const ::IceInternal::UserExceptionFactoryPtr&
Yafridng::FileAccessException::ice_factory()
{
    return __F__Yafridng__FileAccessException__Ptr;
}

class __F__Yafridng__FileAccessException__Init
{
public:

    __F__Yafridng__FileAccessException__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Yafridng::FileAccessException", ::Yafridng::FileAccessException::ice_factory());
    }

    ~__F__Yafridng__FileAccessException__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Yafridng::FileAccessException");
    }
};

static __F__Yafridng__FileAccessException__Init __F__Yafridng__FileAccessException__i;

#ifdef __APPLE__
extern "C" { void __F__Yafridng__FileAccessException__initializer() {} }
#endif

bool
Yafridng::AMI_File_next::__invoke(const ::Yafridng::FilePrx& __prx, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prx->__checkTwowayOnly("next");
        __prepare(__prx, __Yafridng__File__next_name, ::Ice::Normal, __ctx);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
Yafridng::AMI_File_next::__response(bool __ok)
{
    ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response(__ret);
    __releaseCallback();
}

IceAsync::Yafridng::AMD_File_next::AMD_File_next(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::Yafridng::AMD_File_next::ice_response(const ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*>& __ret)
{
    if(__validateResponse(true))
    {
        try
        {
            ::IceInternal::BasicStream* __os = this->__os();
            __os->write(__ret.first, __ret.second);
        }
        catch(const ::Ice::Exception& __ex)
        {
            __exception(__ex);
            return;
        }
        __response(true);
    }
}

void
IceAsync::Yafridng::AMD_File_next::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::Yafridng::AMD_File_next::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

::Ice::ByteSeq
IceProxy::Yafridng::File::next(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Yafridng__File__next_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Yafridng::File* __del = dynamic_cast< ::IceDelegate::Yafridng::File*>(__delBase.get());
            return __del->next(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::Yafridng::File::next_async(const ::Yafridng::AMI_File_nextPtr& __cb)
{
    return __cb->__invoke(this, 0);
}

bool
IceProxy::Yafridng::File::next_async(const ::Yafridng::AMI_File_nextPtr& __cb, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, &__ctx);
}

const ::std::string&
IceProxy::Yafridng::File::ice_staticId()
{
    return ::Yafridng::File::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Yafridng::File::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Yafridng::File);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Yafridng::File::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Yafridng::File);
}

::IceProxy::Ice::Object*
IceProxy::Yafridng::File::__newInstance() const
{
    return new File;
}

::Yafridng::FilePrx
IceProxy::Yafridng::FileStore::read(const ::std::string& name, ::Ice::Int num, ::Ice::Int offset, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Yafridng__FileStore__read_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Yafridng::FileStore* __del = dynamic_cast< ::IceDelegate::Yafridng::FileStore*>(__delBase.get());
            return __del->read(name, num, offset, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Yafridng::FileStore::ice_staticId()
{
    return ::Yafridng::FileStore::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Yafridng::FileStore::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Yafridng::FileStore);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Yafridng::FileStore::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Yafridng::FileStore);
}

::IceProxy::Ice::Object*
IceProxy::Yafridng::FileStore::__newInstance() const
{
    return new FileStore;
}

::Ice::ByteSeq
IceDelegateM::Yafridng::File::next(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Yafridng__File__next_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Ice::ByteSeq __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::std::pair<const ::Ice::Byte*, const ::Ice::Byte*> _____ret;
        __is->read(_____ret);
        ::std::vector< ::Ice::Byte>(_____ret.first, _____ret.second).swap(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Yafridng::FilePrx
IceDelegateM::Yafridng::FileStore::read(const ::std::string& name, ::Ice::Int num, ::Ice::Int offset, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Yafridng__FileStore__read_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
        __os->write(num);
        __os->write(offset);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Yafridng::FileAccessException&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Yafridng::FilePrx __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Yafridng::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::ByteSeq
IceDelegateD::Yafridng::File::next(const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
    return ::Ice::ByteSeq(); // to avoid a warning with some compilers;
}

::Yafridng::FilePrx
IceDelegateD::Yafridng::FileStore::read(const ::std::string& name, ::Ice::Int num, ::Ice::Int offset, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Yafridng::FilePrx& __result, const ::std::string& name, ::Ice::Int num, ::Ice::Int offset, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_name(name),
            _m_num(num),
            _m_offset(offset)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Yafridng::FileStore* servant = dynamic_cast< ::Yafridng::FileStore*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->read(_m_name, _m_num, _m_offset, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Yafridng::FilePrx& _result;
        const ::std::string& _m_name;
        ::Ice::Int _m_num;
        ::Ice::Int _m_offset;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Yafridng__FileStore__read_name, ::Ice::Normal, __context);
    ::Yafridng::FilePrx __result;
    try
    {
        _DirectI __direct(__result, name, num, offset, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Yafridng::FileAccessException&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
Yafridng::File::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Yafridng__File_ids[2] =
{
    "::Ice::Object",
    "::Yafridng::File"
};

bool
Yafridng::File::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Yafridng__File_ids, __Yafridng__File_ids + 2, _s);
}

::std::vector< ::std::string>
Yafridng::File::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Yafridng__File_ids[0], &__Yafridng__File_ids[2]);
}

const ::std::string&
Yafridng::File::ice_id(const ::Ice::Current&) const
{
    return __Yafridng__File_ids[1];
}

const ::std::string&
Yafridng::File::ice_staticId()
{
    return __Yafridng__File_ids[1];
}

::Ice::DispatchStatus
Yafridng::File::___next(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::Yafridng::AMD_File_nextPtr __cb = new IceAsync::Yafridng::AMD_File_next(__inS);
    try
    {
        next_async(__cb, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

static ::std::string __Yafridng__File_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "next"
};

::Ice::DispatchStatus
Yafridng::File::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Yafridng__File_all, __Yafridng__File_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Yafridng__File_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___next(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Yafridng::File::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Yafridng::File::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Yafridng::File::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Yafridng::File was not generated with stream support";
    throw ex;
}

void
Yafridng::File::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Yafridng::File was not generated with stream support";
    throw ex;
}

void 
Yafridng::__patch__FilePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Yafridng::FilePtr* p = static_cast< ::Yafridng::FilePtr*>(__addr);
    assert(p);
    *p = ::Yafridng::FilePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Yafridng::File::ice_staticId(), v->ice_id());
    }
}

bool
Yafridng::operator==(const ::Yafridng::File& l, const ::Yafridng::File& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Yafridng::operator<(const ::Yafridng::File& l, const ::Yafridng::File& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Yafridng::FileStore::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Yafridng__FileStore_ids[2] =
{
    "::Ice::Object",
    "::Yafridng::FileStore"
};

bool
Yafridng::FileStore::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Yafridng__FileStore_ids, __Yafridng__FileStore_ids + 2, _s);
}

::std::vector< ::std::string>
Yafridng::FileStore::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Yafridng__FileStore_ids[0], &__Yafridng__FileStore_ids[2]);
}

const ::std::string&
Yafridng::FileStore::ice_id(const ::Ice::Current&) const
{
    return __Yafridng__FileStore_ids[1];
}

const ::std::string&
Yafridng::FileStore::ice_staticId()
{
    return __Yafridng__FileStore_ids[1];
}

::Ice::DispatchStatus
Yafridng::FileStore::___read(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    ::Ice::Int num;
    ::Ice::Int offset;
    __is->read(name);
    __is->read(num);
    __is->read(offset);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Yafridng::FilePrx __ret = read(name, num, offset, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::Yafridng::FileAccessException& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Yafridng__FileStore_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "read"
};

::Ice::DispatchStatus
Yafridng::FileStore::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Yafridng__FileStore_all, __Yafridng__FileStore_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Yafridng__FileStore_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___read(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Yafridng::FileStore::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Yafridng::FileStore::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Yafridng::FileStore::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Yafridng::FileStore was not generated with stream support";
    throw ex;
}

void
Yafridng::FileStore::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Yafridng::FileStore was not generated with stream support";
    throw ex;
}

void 
Yafridng::__patch__FileStorePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Yafridng::FileStorePtr* p = static_cast< ::Yafridng::FileStorePtr*>(__addr);
    assert(p);
    *p = ::Yafridng::FileStorePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Yafridng::FileStore::ice_staticId(), v->ice_id());
    }
}

bool
Yafridng::operator==(const ::Yafridng::FileStore& l, const ::Yafridng::FileStore& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Yafridng::operator<(const ::Yafridng::FileStore& l, const ::Yafridng::FileStore& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
