#include <Ice/BuiltinSequences.ice>

module Yafridng{

	struct Piece
	{
		int offset;
		int pieceSize;
	};

	sequence<Piece> Pieces;

	exception YafridngException
	{
		string reason;
	};

	exception FileAccessException extends YafridngException
	{
	};


	interface File
	{
		/**
		Next operation returns next expected sequence.
		@return A byte sequence containing readed bytes
		@see Ice::ByteSeq 
		**/

		["ami", "amd", "cpp:array"] Ice::ByteSeq next();
	};

	interface FileStore
	{
		/**
		La operacion read abre un archivo en el servidor y nos
		devuelve un proxy File para su posterior lectura.
		Read operation opens a file in the server and returns a File
		proxy for the reading.

		@param name Name of the file to read.
		@param num The number of bytes to be transferred with each
		call to function [next].

		@param offset The position from where a file is going to be
		read.

		@throws FileAccessException if there is some error opening the
		file a FileAccessException is raised. 

		@return A [File] proxy.

		@see FileAccessException
		@see File
		**/
		File* read(string name, int num, int offset)
		throws FileAccessException;
   };
};
